{{***************************************************

A P1V DE2-115 Retromachine demo v. 0.98 - 2014.11.22
Piotr Kardasz, pik33@o2.pl
MIT license

*****************************************************}}

con


  _clkmode = xtal1+pll16x
  _clkfreq = 114_285_714


obj

  vga           : "vnfg098"
  i2c           : "i2cdrv"
  kbm           : "PS2_HIDEngine"

pub demo | cnt2, random, i, j, k,s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,x,y,r,g,b,kx1,kx2,kx3,kx4,kx5,kx6,ky1,ky2,ky3,ky4,ky5,ky6

  s1:=string("VGA Nostalgic graphics with border driver demo")
  s2:=string("It uses Atari ST mono 8x16 font")
  s3:=string("It can draw pixels, lines, circles, boxes and characters ")
  s4:=string("Graphics mode 0 - 1792x1120x4 colors")
  s5:=string("The framebuffer is located in DE2-115 SRAM and accessed via extended port B")
  s6:=string("Graphics mode 5 - 896x560x16 colors")
  s7:=string("This version is slow, the graphics procedures are written in Spin")
  s8:=string("Graphics mode 10")  
  s9:=string("448x280x256 colors")
  s10:=string("READY")
  j:=0



vga.start
kbm.start(26,27,24,25,0,1792,1120)
kbm.mouseConfiguration(3, 0)
vga.setgraypallette(3)
vga.setataripallette(0)
initsound
initsamples

repeat i from $83000 to $8300f     ' clear display registers
  vga.poke(i,0)
repeat i from $84000 to $843FF     ' clear audio buffer
  vga.poke(i,0) 
repeat i from $20000 to $21000     ' clear DL area
  vga.poke(i,0) 

vga.poke($83000+36,0)              ' switch off leds and hex
vga.poke($83000+37,$FFFFFFFF)
vga.poke($83000+38,$FFFFFFFF)

'vga.setcharmode(1,45)

repeat
  beep(0,0,0)
  beep(1,0,0)
  beep(2,0,0)
  beep(3,0,0)
  vga.graphics(9)
  vga.cls
  vga.setataripallette (0)               ' init pallette 0 with 8-bit Atari colors
  vga.setgraypallette (1)                ' init pallette 1 with grayscale
  vga.poke($83000+43,160)
  vga.poke($83000+44,224)
  initsprites
  i:=$93939393
  vga.poke($20000,$93939393)
  vga.poke($20001,$25262728)    

  
  vga.cls
 ' i:=cnt
  vga.blit3($20000,0,62720,$FFFFFFFF,0,1)
 ' i:=cnt-i
 ' vga.blit3($20001,1140,100,$FFFFFFFF,0,112)
 ' vga.box2(100,100,200,200,72)                                                                
 ' vga.outtextxy(300,300,vga.inttostr(i),40)
 ' waitcnt(cnt+clkfreq)
 ' vga.line(0,15,320,15,136)
 ' vga.line(0,33,320,33,136)
 ' vga.line(15,0,15,320,136)
 ' vga.line(33,0,33,320,136)
   
 ' vga.box(15,15,33,33,40)
 ' vga.poke($83002,13)



  
  vga.outtextxy(40,16,string("A DE2-115 Propeller powered retrocomputer demo"),155)
  waitcnt(cnt+clkfreq)
  vga.outtextxy(8,32,string ("We are now in graphics mode 9 - 448x560 in 256 colors"),155)
  vga.poke($8302f,11200)
  vga.outtextxy(40,16,string("Start address register test"),155)
  waitcnt(cnt+clkfreq)
  vga.setcharmode(1,45) 
  vga.outtextxy(8,32,string ("This text should be visible on light red background"),155)
  vga.setcharmode(0,0)
  vga.poke($8302f,0)  
  waitcnt(cnt+clkfreq<<2)
  

  vga.outtextxy(16,48,string (" Blit scroller test "),155)                
  repeat i from 0 to 31 step 8
    vga.poke($8302D,i+$80000000)
    repeat j from 112*48 to 112*63 step 112
      k:=32
      repeat 
        vga.poke(j+k,vga.peek(j+k))
        k:=k-1
      until k<4  
    waitcnt(cnt+clkfreq)
  vga.poke($8302d,0)
  vga.box(0,0,447,559,147) 
    
  vga.outtextxy(40,16,string("A DE2-115 Propeller powered retrocomputer demo"),155)

  vga.outtextxy(8,32,string ("We are now in graphics mode 9 - 448x560 in 256 colors"),155)
  
  vga.outtextxy(8,64,string ("We have:"),155)
  waitcnt(cnt+clkfreq)

  vga.outtextxy(8,96,string ("2 MB (512kx32) chip RAM at $0 to $7FFFF"),155)
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(8,112,string ("128 MB (32Mx32) fast RAM at $200_0000 to $3FF_FFFF"),155)
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(8,128,string ("A Propeller 8-core microcontroller @ 114 MHz"),155)
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(8,144,string ("A SD card connected to the Propeller at P20..P23"),155)
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(8,160,string ("A keyboard and mouse at P24..P27"),155)
  waitcnt(cnt+clkfreq)
  vga.outtextxy(8,176,string ("Atari-8-bit-like pallette"),155)  
  waitcnt(cnt+clkfreq) 
  repeat i from 0 to 15
    repeat j from 0 to 15
      vga.box(8+8*j,200+16*i,8+8*j+7,200+16*i+15,j+16*i)
  waitcnt(cnt+clkfreq)

  vga.set332pallette(0)
  vga.box(300,300,400,400,255)
  waitcnt(cnt+clkfreq)
  vga.setataripallette(0)    
  vga.outtextxy(8,476,string ("A sound buffer and 4-channel sound synth..."),155) 
  waitcnt(cnt+clkfreq)
  vga.outtextxy(160,240,string ("Channel 0"),40)
  fire(0,0)
  waitcnt(cnt+clkfreq)
  vga.outtextxy(160,280,string ("Channel 1"),72)
  fire(1,1)
  waitcnt(cnt+clkfreq)

  vga.outtextxy(160,320,string ("Channel 2"),136)
  fire(2,2)
  waitcnt(cnt+clkfreq)

  vga.outtextxy(160,360,string ("Channel 3"),168)
  fire(3,3)
  waitcnt(cnt+clkfreq)
  vga.outtextxy(160,400,string ("All..."),200)
  
  beep(0,523,$10001000)
  waitcnt(cnt+clkfreq) 
  beep(1,659,$10001000)
  waitcnt(cnt+clkfreq)
  beep(2,784,$10001000)
  waitcnt(cnt+clkfreq)
  beep(3,1046,$10001000) 
  waitcnt(cnt+clkfreq)
  beep(1,0,0)
  beep(2,0,0)
  beep(3,0,0)
  waitcnt(cnt+clkfreq>>1)    
  beep(1,659,$10001000)
  waitcnt(cnt+clkfreq>>1)
  beep(2,784,$10001000)
  waitcnt(cnt+clkfreq>>1)
  beep(3,1046,$10001000)
  waitcnt(cnt+clkfreq>>1)   
  beep(1,0,0)
  beep(2,0,0)
  beep(3,0,0)
  waitcnt(cnt+clkfreq>>2)    
  beep(1,659,$10001000)
  waitcnt(cnt+clkfreq>>2)
  beep(2,784,$10001000)
  waitcnt(cnt+clkfreq>>2)
  beep(3,1046,$10001000) 
  waitcnt(cnt+clkfreq<<2)
  beep(0,0,0)
  beep(1,0,0)
  beep(2,0,0)
  beep(3,0,0)

 {
// 0 - display state: {vsync,hsync,frame counter}
// 1 - display start address
// 2 - mode
// 3 - border
// 4 - pallette bank
// 5 - mode 0 - 4 sprites @ full color; 1 - 16 sprites @ 256 colors; bits 3..2 - pallette selector
// 6 - display list start address; bit 31: dl active
//..7 reserved
// 8..23 sprite x, sprite y, 2 high bits - width/height zoom

// display list 
// [31] - entry valid
// [30] - generate dli
// [29..22] palette index
// [21..18] mode
// [17..0] line start address
  }

  vga.outtextxy(8,492,string ("...and 6 32x32 pixels sprites with a collision register"),155)
  waitcnt(cnt+clkfreq)
  movesprites(1200,$40004000)    
  movesprites(3600,$80008000)
  movesprites(1200,$00000000)
      
  vga.poke ($83009,$80008000+2000) 'move sprites away 
  vga.poke ($8300a,$80008000+2000)
  vga.poke ($8300b,$80008000+2000)
  vga.poke ($8300c,$80008000+2000)
  vga.poke ($8300d,$80008000+2000)     
  vga.poke ($8300e,$80008000+2000) 
  beep(0,0,0)
  beep(1,0,0)
  vga.outtextxy(8,508,string ("We have procedures for graphics primitives drawing"),155)  
  waitcnt(cnt+clkfreq)
  vga.outtextxy(8,524,string ("so let's switch to graphics mode 10"),155)
  vga.blit1(0,$2_000_000,64000)

  repeat i from 2 to 560 step 2
    vga.blit1(0,62720,1792)
    vga.blit1(1792,0,62720)
    waitpeq (1,1,0)   
'    waitcnt(cnt+clkfreq)
  repeat i from 2 to 560 step 2
    y:=i*112
    waitpeq (1,1,0)
    waitpeq (0,1,0)       
    vga.blit1($2_000_000+y,0,62832-y)
    vga.blit1($2_000_000,62720-y,y)
'    waitpeq (1,1,0)
  
  waitcnt(cnt+clkfreq<<2)
  vga.blit1(112*16,0,256000)

  vga.graphics(10)
  vga.cls

  repeat i from 0 to 10000
   x:=random?&511
   y:=random?&255
   r:=x+10+random?&63
   g:=y+10+random?&63  
   b:=random?&255
   vga.box(x,y,r,g,b)
  waitcnt(cnt+clkfreq)
  repeat i from 0 to 300
   x:=random?&511
   y:=random?&255
   r:=10+random?&31
   b:=random?&255
   vga.fcircle(x,y,r,b)
  waitcnt(cnt+clkfreq)

  vga.border(0,0,128)                      'set dark blue border


  repeat i from 0 to 139
    vga.frame(0+i,0+i,447-i,279-i,i)
  waitcnt(cnt+clkfreq<<2)
  vga.box(48,48,416,128,232) 
  vga.outtextxy(56,56,string("Graphics mode 10 - 448x280 in 256 colors"),104)
  waitcnt(cnt+clkfreq<<2)  
  vga.border(0,255,0)               ' the border color is random after HBL

  vga.box(48,48,416,128,232) 
  vga.outtextxy(128,56,string("Let's save the screen in SDRAM"),104)
  waitcnt(cnt+clkfreq<<1) 
  vga.blit1(0, $2000000,31360) 
  vga.cls
  vga.border(255,255,0)
  vga.outtextxy(16,104,string("Now the screen is stored in SDRAM. Let's restore it"),168)
  waitcnt(cnt+clkfreq<<1)     
  vga.blit1($2000000,0,31360) 
  waitcnt(cnt+clkfreq<<1)
  vga.border(255,255,255)     
  vga.box2(48,48,416,128,232) 
  vga.outtextxy(128,56,string("Now the screen is restored"),104)
  vga.outtextxy(112,80,string ("Let's switch to graphics mode 5"),24)
  waitcnt(cnt+clkfreq<<1)

  vga.graphics(5)
  vga.cls
'  vga.poke ($83003,0)
  vga.poke($83004,1)                      ' pallette select #0 
  vga.setcolor (16,0,0,0)
  vga.outtextxy(10,10,string("Nostalgic graphics driver for P1V and DE2-115"),3)
  waitcnt(cnt+clkfreq) 
  vga.outtextxy(10,30,string("We are now in graphics mode 5 - 896x560 in 16 colors"),5)
  waitcnt(cnt+clkfreq) 
  vga.outtextxy(10,50,string("The colors can be selected from 24-bit color redefinable palette"),7)
  waitcnt(cnt+clkfreq) 
  vga.outtextxy(10,70,string("The driver use 8x16 Atari ST font. The font is redefinable, too"),9)
  waitcnt(cnt+clkfreq<<2)   
  vga.cls
  repeat i from 0 to 15
    vga.setcolor (16*i,0,0,0) 
  vga.poke($83004,12)   
  vga.outtextxy(10,10,string("The mode 5 is 16 color mode..."),1)
  waitcnt(cnt+clkfreq)
  repeat i from 0 to 15
    repeat j from 0 to 15
      vga.box(10+i*16,100+j*16,25+i*16,115+j*16,i)


    
  waitcnt(cnt+clkfreq) 
  vga.outtextxy(10,30,string("...but we have a display list..."),3)
  repeat i from 0 to 15
    vga.setcolor (16*i,0,0,0)  

  vga.poke($83006,$80020000)
  vga.poke($20107,%11_0000_0000_0101_1111_1111_1111_1111_11)
  vga.poke($20129,%11_0000_0001_0101_1111_1111_1111_1111_11)
  vga.poke($20149,%11_0000_0010_0101_1111_1111_1111_1111_11)
  vga.poke($20169,%11_0000_0011_0101_1111_1111_1111_1111_11)
  vga.poke($20189,%11_0000_0100_0101_1111_1111_1111_1111_11)
  vga.poke($201a9,%11_0000_0101_0101_1111_1111_1111_1111_11)
  vga.poke($201c9,%11_0000_0110_0101_1111_1111_1111_1111_11)
  vga.poke($201e9,%11_0000_0111_0101_1111_1111_1111_1111_11)
  vga.poke($20209,%11_0000_1000_0101_1111_1111_1111_1111_11)
  vga.poke($20229,%11_0000_1001_0101_1111_1111_1111_1111_11)
  vga.poke($20249,%11_0000_1010_0101_1111_1111_1111_1111_11)
  vga.poke($20269,%11_0000_1011_0101_1111_1111_1111_1111_11)
  vga.poke($20289,%11_0000_1100_0101_1111_1111_1111_1111_11)
  vga.poke($202a9,%11_0000_1101_0101_1111_1111_1111_1111_11)
  vga.poke($202c9,%11_0000_1110_0101_1111_1111_1111_1111_11)
  vga.poke($202e9,%11_0000_1111_0101_1111_1111_1111_1111_11)
  vga.poke($20309,%11_0000_1100_0101_1111_1111_1111_1111_11)

  waitcnt(cnt+clkfreq) 
  vga.outtextxy(10,50,string("... so we can use it and display Atari-8-bit-like pallette"),5)       
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(10,370,string("We have horizontal fine scroll register"),7)       
  waitcnt(cnt+clkfreq)  
  vga.outtextxy(10,390,string("Let's use it..."),5)       
 
  repeat j from 0 to 1
    repeat i from 0 to 512 step 2<<j
      vga.poke ($83007,i)
      waitcnt(cnt+clkfreq/80)     
      repeat
      until ina[0]==1
    repeat i from 0 to 512 step 2<<j

      vga.poke($83007, 512-i  )
      waitcnt(cnt+clkfreq/80)   
      repeat
      until ina[0]==1

  vga.poke ($83007,0) 
  vga.outtextxy(10,410,string("Let's switch the display list off..."),5)       
  vga.poke($83006,0)
  waitcnt(cnt+clkfreq)
  vga.outtextxy(10,430,string("... and set the pallette #0 color 1 white"),1)       
  vga.setcolor (1,255,255,255)    
  vga.poke ($83007,0)
  vga.poke ($83004,0)
  waitcnt (cnt+clkfreq<<2)
  vga.poke($83006,0)
  vga.outtextxy(10,450,string("Then let's blink some LEDs"),1)
  vga.poke ($83029,1)      
  i:=1
  repeat k from 0 to 10
    repeat j from 0 to 31
      vga.poke($83024,i<<j)
      waitcnt(cnt+clkfreq>>4) 
  vga.poke ($83029,0)

  
  vga.cls
  
  vga.outtextxy(10,10,string("We have 12 different graphics modes"),1)     
  waitcnt (cnt+clkfreq<<2) 
  vga.setcolor(1,255,255,255)
  vga.graphics (0)
  vga.cls
  vga.outtextxy(10,10,string("graphics 0 - 1792x1120 in 4 colors"),1)    
  waitcnt (cnt+clkfreq) 
  vga.graphics (1)
  vga.cls
  vga.outtextxy(10,10,string("graphics 1 - 1792x560 in 4 colors"),1)     
  waitcnt (cnt+clkfreq)              
  vga.graphics (2)
  vga.cls
  vga.outtextxy(10,10,string("graphics 2 - 1792x280 in 4 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (3)
  vga.cls
  vga.outtextxy(10,10,string("graphics 3 - 1792x140 in 4 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (4)
  vga.cls
  vga.outtextxy(10,10,string("graphics 4 - 896x1120 in 16 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (5)
  vga.cls
  vga.outtextxy(10,10,string("graphics 5 - 896x560 in 16 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (6)
  vga.cls
  vga.outtextxy(10,10,string("graphics 6 - 896x280 in 16 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (7)
  vga.cls
  vga.outtextxy(10,10,string("graphics 7 - 896x140 in 16 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (8)
  vga.cls
  vga.outtextxy(10,10,string("graphics 8 - 448x1120 in 256 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (9)
  vga.cls
  vga.outtextxy(10,10,string("graphics 9 - 448x560 in 256 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (10)
  vga.cls
  vga.outtextxy(10,10,string("graphics 10 - 448x280 in 256 colors"),1)     
  waitcnt (cnt+clkfreq) 
  vga.graphics (11)
  vga.cls
  vga.outtextxy(10,10,string("graphics 11 - 448x140 in 256 colors"),1)     
  waitcnt (cnt+clkfreq) 
  waitcnt (cnt+clkfreq)


 
  vga.graphics(0)
  vga.cls
  vga.setcolor(1,0,192,0)
  vga.outtextxy(10,10,string("So if we want to have high-res graphics or even a GUI, we can use high resolution mode"),1)
  waitcnt (cnt+clkfreq<<2)
  vga.setcolor(0,0,192,0)
  vga.setcolor(1,255,255,255)
  vga.setcolor(2,0,0,0)
  vga.setcolor(3,0,0,255)
  vga.cls
  vga.initmouse
  vga.poke ($83009,$30000000+(300<<16)+300)
  vga.box(0,0,1791,23,1)
  vga.outtextxy(8,4,string("File  Options  View  Settings"),2)   
  vga.line(0,200,1000,200,2)
  vga.line(0,399,1000,399,2)
  vga.line(200,100,200,1000,2)
  vga.line(699,100,699,1000,2)
  
  vga.box(200,200,699,399,1)
  vga.frame(200,200,699,399,2)
  vga.line(200,224,699,224,2)
  vga.line(200,248,699,248,2)
  vga.line(224,200,224,224,2)
    
  vga.outtextxy(400,204,string("SD1:\"),2)  
  vga.outtextxy(224,228,string("4 898 432 567 bytes in 7 objects"),2)   
  vga.outtextxy(224,256,string("DOS     .SYS         49 345   2014.10.19  13:21"),2)   
  vga.outtextxy(224,272,string("DUP     .SYS         22 378   2014.10.19  13:22"),2)   
  vga.outtextxy(224,288,string("AVATAR  .MP4  4 021 353 218   2009.02.25  20:42"),2)   
  vga.outtextxy(224,304,string("ESKIMO  .SID      2 512 888   2010.04.02  08:21"),2)   
  vga.outtextxy(224,320,string("PROGRAM .BAS        388 776   2014.10.18  12:34"),2)   
  vga.outtextxy(224,336,string("PROGRAM .EXE      7 486 229   2013.06.15  04:22"),2)   
  vga.outtextxy(224,352,string("MUSIC   .MP3     23 327 379   2008.01.23  23:45"),2)   




    

  vga.outtextxy(900,100,string("If you have connected the mouse to PS2 socket"),3)   
  vga.outtextxy(900,116,string("you can draw and play with the left mouse button."),3)   
  vga.outtextxy(900,132,string("Press right mouse button to restart the demo"),3)   
  vga.outtextxy(900,148,string("If you have no mouse, press Key 0 to reset"),3)   


  vga.poke($83000+32,$10001000)
  vga.poke($83000+33,$0)
  vga.poke($83000+34,0)
  vga.poke($83000+35,0)


  repeat i from 16 to 20
    vga.poke($83000+i,0)
  
  vga.poke($83000+24,$60000)
  vga.poke($83000+28,512)
  repeat

    kx3:=kx2
    kx2:=kbm.xposition 
    kx1:=kbm.xposition +159

    ky3:=ky2
    ky2:=kbm.yposition 
    ky1:=kbm.yposition +66


    vga.poke($83000+20,(kbm.xposition<<6))
'    vga.poke($83000+32,(kbm.yposition<<4)+(kbm.yposition<<20))


'    vga.poke($83003,vga.peek($80000+kbm.zposition&255))
    vga.poke ($83009,$30000000+kx1+((ky1)<<16))   
    if kbm.leftbutton                           
                                               
      vga.line(kx3,ky3,kx2,ky2,3)
      vga.poke($83000+32,(kbm.yposition<<4)+(kbm.yposition<<20))
    else
      vga.poke($83020,0)        
  until kbm.rightbutton

  
  
pub initsprites |i,j

  vga.poke ($83009,$80008000+2000) 'move sprites away 
  vga.poke ($8300a,$80008000+2000)
  vga.poke ($8300b,$80008000+2000)
  vga.poke ($8300c,$80008000+2000)
  vga.poke ($8300d,$80008000+2000)     
  vga.poke ($8300e,$80008000+2000)
 
  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82000+8*i+j,$20202020+(i<<0)+(i<<8)+(i<<16)+(i<<24))
      else
        vga.poke($82000+8*i+j,$20202020+((31-i)<<0)+((31-i)<<8)+((31-i)<<16)+((31-i)<<24))

  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82100+8*i+j,$40404040+(i<<0)+(i<<8)+(i<<16)+(i<<24))
      else
        vga.poke($82100+8*i+j,$40404040+((31-i)<<0)+((31-i)<<8)+((31-i)<<16)+((31-i)<<24))

  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82200+8*i+j,$60606060+(i<<0)+(i<<8)+(i<<16)+(i<<24))
      else
        vga.poke($82200+8*i+j,$60606060+((31-i)<<0)+((31-i)<<8)+((31-i)<<16)+((31-i)<<24))

  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82300+8*i+j,$08080808+(i<<4)+(i<<12)+(i<<20)+(i<<28))
      else
        vga.poke($82300+8*i+j,$08080808+((31-i)<<4)+((31-i)<<12)+((31-i)<<20)+((31-i)<<28))

  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82400+8*i+j,$c0c0c0c0+(i<<0)+(i<<8)+(i<<16)+(i<<24))
      else
        vga.poke($82400+8*i+j,$c0c0c0c0+((31-i)<<0)+((31-i)<<8)+((31-i)<<16)+((31-i)<<24))

  repeat i from 0 to 31
    repeat j from 0 to 7
      if i<16
        vga.poke($82500+8*i+j,$f0f0f0f0+(i<<0)+(i<<8)+(i<<16)+(i<<24))
      else
        vga.poke($82500+8*i+j,$f0f0f0f0+((31-i)<<0)+((31-i)<<8)+((31-i)<<16)+((31-i)<<24))

  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82000+8*i+j,0)

  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82100+8*i+j,0)


  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82200+8*i+j,0)

  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82300+8*i+j,0)

  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82400+8*i+j,0)

  repeat i from 10 to 22
    repeat j from 2 to 5
       vga.poke($82500+8*i+j,0)


pub movesprites(j,size) |i,dx1,dx2,dx3,dx4,dy1,dy2,dy3,dy4,s1x,s2x,s3x,s4x,s1y,s2y,s3y,s4y,dx5,dx6,dy5,dy6,s5y,s6y,s5x,s6x,cnt2,random ,cnt3

  cnt2:=0
  random:=cnt

  
  s1x:=160
  s1y:=67
  s2x:=360
  s2y:=77
  s3x:=560
  s3y:=87
  s4x:=760
  s4y:=107
  s5x:=970
  s5y:=130
  s6x:=600
  s6y:=900
  

  dx1:=1+random?&3
  dy1:=1+random?&3
  dx2:=1+random?&3
  dy2:=1+random?&3
  dx3:=1+random?&3
  dy3:=1+random?&3
  dx4:=1+random?&3
  dy4:=1+random?&3
  dx5:=1+random?&3
  dy5:=1+random?&3
  dx6:=1+random?&3
  dy6:=1+random?&3
  
  repeat i from 1 to j

    s1x:=s1x+dx1
    s2x:=s2x+dx2
    s3x:=s3x+dx3
    s4x:=s4x+dx4
    s5x:=s5x+dx5
    s6x:=s6x+dx6

    s1y:=s1y+dy1
    s2y:=s2y+dy2
    s3y:=s3y+dy3
    s4y:=s4y+dy4
    s5y:=s5y+dy5
    s6y:=s6y+dy6


    if s1x>1823+64
      dx1:=-dx1 
    if s2x>1823+64
      dx2:=-dx2 
    if s3x>1823+64
      dx3:=-dx3 
    if s4x>1823+64
      dx4:=-dx4 
    if s5x>1823+64
      dx5:=-dx5
    if s6x>1823+64
      dx6:=-dx6 


    if s1y>1058+64
      dy1:=-dy1 
    if s2y>1058+64
      dy2:=-dy2 
    if s3y>1058+64
      dy3:=-dy3 
    if s4y>1058+64
      dy4:=-dy4
    if s5y>1058+64
      dy5:=-dy5
    if s6y>1058+64
      dy6:=-dy6


   if s1x<159
      dx1:=-dx1    
   if s2x<159 
      dx2:=-dx2    
   if s3x<159 
      dx3:=-dx3    
   if s4x<159 
      dx4:=-dx4    
   if s5x<159 
      dx5:=-dx5    
   if s6x<159 
      dx6:=-dx6    
 
   if s1y<66 
      dy1:=-dy1    
   if s2y<66
      dy2:=-dy2    
   if s3y<66
      dy3:=-dy3    
   if s4y<66
      dy4:=-dy4    
   if s5y<66
      dy5:=-dy5
   if s6y<66
      dy6:=-dy6             
            
   repeat until ina[0]==1
   if (((vga.peek($8300f)&1)==1) and (cnt2==0))
     cnt2:=6
     dx1:=-dx1
     dy1:=-dy1
     dx2:=-dx2
     dy2:=-dy2
     beep(0,1000,$10001000)        
   if (((vga.peek($8300f)&2)==2) and (cnt2==0))
     cnt2:=6
     dx1:=-dx1
     dy1:=-dy1
     dx3:=-dx3
     dy3:=-dy3
     beep(0,1100,$10001000)        
   if (((vga.peek($8300f)&4)==4) and (cnt2==0))
     cnt2:=6
     dx1:=-dx1
     dy1:=-dy1
     dx4:=-dx4
     dy4:=-dy4
     beep(0,1200,$10001000)        
   if (((vga.peek($8300f)&8)==8) and (cnt2==0))
     cnt2:=6
     dx1:=-dx1
     dy1:=-dy1
     dx5:=-dx5
     dy5:=-dy5
     beep(0,1300,$10001000)        
   if (((vga.peek($8300f)&16)==16) and (cnt2==0))
     cnt2:=6
     dx1:=-dx1
     dy1:=-dy1
     dx6:=-dx6
     dy6:=-dy6
     beep(0,1400,$10001000)        
   if (((vga.peek($8300f)&32)==32) and (cnt2==0))
     cnt2:=6
     dx2:=-dx2
     dy2:=-dy2
     dx3:=-dx3
     dy3:=-dy3
     beep(0,1500,$10001000)        
   if (((vga.peek($8300f)&64)==64) and (cnt2==0))
     cnt2:=6
     dx2:=-dx2
     dy2:=-dy2
     dx4:=-dx4
     dy4:=-dy4
     beep(0,1600,$10001000)        
   if (((vga.peek($8300f)&128)==128) and (cnt2==0))
     cnt2:=6
     dx2:=-dx2
     dy2:=-dy2
     dx5:=-dx5
     dy5:=-dy5
     beep(0,1700,$10001000)        
   if (((vga.peek($8300f)&256)==256) and (cnt2==0))
     cnt2:=6
     dx2:=-dx2
     dy2:=-dy2
     dx6:=-dx6
     dy6:=-dy6
     beep(0,1800,$10001000)        
   if (((vga.peek($8300f)&512)==512) and (cnt2==0))
     cnt2:=6
     dx3:=-dx3
     dy3:=-dy3
     dx4:=-dx4
     dy4:=-dy4
     beep(0,1900,$10001000)        
   if (((vga.peek($8300f)&1024)==1024) and (cnt2==0))
     cnt2:=6
     dx3:=-dx3
     dy3:=-dy3
     dx5:=-dx5
     dy5:=-dy5
     beep(0,2000,$10001000)        
   if (((vga.peek($8300f)&2048)==2048) and (cnt2==0))
     cnt2:=6
     dx3:=-dx3
     dy3:=-dy3
     dx6:=-dx6
     dy6:=-dy6
     beep(0,2100,$10001000)        
   if (((vga.peek($8300f)&4096)==4096) and (cnt2==0))
     cnt2:=6
     dx4:=-dx4
     dy4:=-dy4
     dx5:=-dx5
     dy5:=-dy5
     beep(0,2200,$10001000)
   if (((vga.peek($8300f)&8192)==8192) and (cnt2==0))
     cnt2:=6
     dx4:=-dx4
     dy4:=-dy4
     dx6:=-dx6
     dy6:=-dy6
     beep(0,2300,$10001000)   
   if (((vga.peek($8300f)&16384)==16384) and (cnt2==0))
     cnt2:=6
     dx5:=-dx5
     dy5:=-dy5
     dx6:=-dx6
     dy6:=-dy6
     beep(0,2400,$10001000)

   if (((vga.peek($8300f)&32768)==32768) and (cnt2==0))
     cnt3:=6  
     beep(1,2500,$10001000)

   if (((vga.peek($8300f)&65536)==65536) and (cnt2==0))

     cnt3:=6  
     beep(1,2600,$10001000)

   if (((vga.peek($8300f)&131072)==131072) and (cnt2==0))
     cnt3:=6  
     beep(1,2700,$10001000)

   if (((vga.peek($8300f)&262144)==262144) and (cnt2==0))

     cnt3:=6  
     beep(1,2800,$10001000)

   if (((vga.peek($8300f)&524288)==524288) and (cnt2==0))
  
     cnt3:=6
     beep(1,2900,$10001000)

   if (((vga.peek($8300f)&1048576)==1048576) and (cnt2==0))
     cnt3:=6  
     beep(1,3000,$10001000)
  
   cnt2:=cnt2-1
   if cnt2<0
     cnt2:=0
   if cnt2==0
     beep(0,0,0) 
   cnt3:=cnt3-1
   if cnt3==0
     beep(1,0,0)
   vga.poke ($83009,size+s1x+s1y<<16)
   vga.poke ($8300a,size+s2x+s2y<<16)
   vga.poke ($8300b,size+s3x+s3y<<16)
   vga.poke ($8300c,size+s4x+s4y<<16)
   vga.poke ($8300d,size+s5x+s5y<<16)
   vga.poke ($8300e,size+s6x+s6y<<16)
   vga.poke ($8300f,0)
   repeat until ina[0]==0



pub initsound

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,1)
i2c.write(18,$1f)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$8)
i2c.write(18,$12)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0a)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0c)
i2c.write(18,$62)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0e)
i2c.write(18,$1b)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$10)
i2c.write(18,$22)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$6)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$4)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$1)
i2c.stop(18)   


pub beep(channel, freq, vol)

freq:=freq*23777
freq:=freq/1000
vga.poke($83000+20+channel,freq)
vga.poke($83000+32+channel,vol)  


pub fire(channel,div)   |i,j

'*** Make a demo sound

vga.poke($83000+32+channel,10000+(10000<<16))  
vga.poke($83000+24+channel,$60000)
vga.poke($83000+28+channel,512)                                                                                                      

repeat j from 30 to 150 step 3
  repeat i from 4096 to 180000 step j
   vga.poke($83000+20+channel,i>>div)

vga.poke($83000+32+channel,0)
vga.poke($83010+channel,0)


pub initsamples   |i            

'*** pokes a triangle wave samples, 256 longs from $60000

repeat i from 0 to 127
  vga.poke($60000+i,((128+i)<<8)+((128+i)<<24))
  vga.poke($601FF-i,((128+i)<<8)+((128+i)<<24))
repeat i from 0 to 127
  vga.poke($60080+i,(i<<8)+(i<<24))
  vga.poke($6017F-i,(i<<8)+(i<<24))
vga.poke ($60000,$80008000)
vga.poke ($60200,$80008000)

'******************************** End of demo ************************************************************************
'*********************************************************************************************************************